SDL_clipboard.h File Reference
`#include <SDL3/SDL_stdinc.h>`
`#include <SDL3/SDL_error.h>`
`#include <SDL3/SDL_begin_code.h>`
`#include <SDL3/SDL_close_code.h>`
Include dependency graph for SDL_clipboard.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Typedefs

typedef const void *(* | SDL_ClipboardDataCallback) (void *userdata, const char *mime_type, size_t *size)
typedef void(* | SDL_ClipboardCleanupCallback) (void *userdata)

## Functions

bool | SDL_SetClipboardText (const char *text)
char * | SDL_GetClipboardText (void)
bool | SDL_HasClipboardText (void)
bool | SDL_SetPrimarySelectionText (const char *text)
char * | SDL_GetPrimarySelectionText (void)
bool | SDL_HasPrimarySelectionText (void)
bool | SDL_SetClipboardData (SDL_ClipboardDataCallback callback, SDL_ClipboardCleanupCallback cleanup, void *userdata, const char **mime_types, size_t num_mime_types)
bool | SDL_ClearClipboardData (void)
void * | SDL_GetClipboardData (const char *mime_type, size_t *size)
bool | SDL_HasClipboardData (const char *mime_type)
char ** | SDL_GetClipboardMimeTypes (size_t *num_mime_types)

## Typedef Documentation

## SDL_ClipboardCleanupCallback

typedef void(* SDL_ClipboardCleanupCallback) (void *userdata)

Callback function that will be called when the clipboard is cleared, or new data is set.

Parameters

  userdata | a pointer to provided user data.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_SetClipboardData

Definition at line 223 of file SDL_clipboard.h.

## SDL_ClipboardDataCallback

typedef const void *(* SDL_ClipboardDataCallback) (void *userdata, const char *mime_type, size_t *size)

Callback function that will be called when data for the specified mime-type is requested by the OS.

The callback function is called with NULL as the mime_type when the clipboard is cleared or new data is set. The clipboard is automatically cleared in SDL_Quit().

Parameters

  userdata | a pointer to provided user data.
  mime_type | the requested mime-type.
  size | a pointer filled in with the length of the returned data.

Returns
  a pointer to the data for the provided mime-type. Returning NULL or setting length to 0 will cause no data to be sent to the "receiver". It is up to the receiver to handle this. Essentially returning no data is more or less undefined behavior and may cause breakage in receiving applications. The returned data will not be freed so it needs to be retained and dealt with internally.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_SetClipboardData

Definition at line 211 of file SDL_clipboard.h.

## Function Documentation

## SDL_ClearClipboardData()

bool SDL_ClearClipboardData | ( | void |  | ) |

extern

Clear the clipboard data.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_SetClipboardData

## SDL_GetClipboardData()

void * SDL_GetClipboardData | ( | const char * | mime_type,
|  | size_t * | size
| ) |  |

extern

Get the data from clipboard for a given mime type.

The size of text data does not include the terminator, but the text is guaranteed to be null terminated.

Parameters

  mime_type | the mime type to read from the clipboard.
  size | a pointer filled in with the length of the returned data.

Returns
  the retrieved data buffer or NULL on failure; call SDL_GetError() for more information. This should be freed with SDL_free() when it is no longer needed.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_HasClipboardData
  SDL_SetClipboardData

## SDL_GetClipboardMimeTypes()

char ** SDL_GetClipboardMimeTypes | ( | size_t * | num_mime_types | ) |

extern

Retrieve the list of mime types available in the clipboard.

Parameters

  num_mime_types | a pointer filled with the number of mime types, may be NULL.

Returns
  a null terminated array of strings with mime types, or NULL on failure; call SDL_GetError() for more information. This should be freed with SDL_free() when it is no longer needed.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_SetClipboardData

## SDL_GetClipboardText()

char * SDL_GetClipboardText | ( | void |  | ) |

extern

Get UTF-8 text from the clipboard.

This functions returns an empty string if there was not enough memory left for a copy of the clipboard's content.

Returns
  the clipboard text on success or an empty string on failure; call SDL_GetError() for more information. This should be freed with SDL_free() when it is no longer needed.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_HasClipboardText
  SDL_SetClipboardText

## SDL_GetPrimarySelectionText()

char * SDL_GetPrimarySelectionText | ( | void |  | ) |

extern

Get UTF-8 text from the primary selection.

This functions returns an empty string if there was not enough memory left for a copy of the primary selection's content.

Returns
  the primary selection text on success or an empty string on failure; call SDL_GetError() for more information. This should be freed with SDL_free() when it is no longer needed.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_HasPrimarySelectionText
  SDL_SetPrimarySelectionText

## SDL_HasClipboardData()

bool SDL_HasClipboardData | ( | const char * | mime_type | ) |

extern

Query whether there is data in the clipboard for the provided mime type.

Parameters

  mime_type | the mime type to check for data for.

Returns
  true if there exists data in clipboard for the provided mime type, false if it does not.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_SetClipboardData
  SDL_GetClipboardData

## SDL_HasClipboardText()

bool SDL_HasClipboardText | ( | void |  | ) |

extern

Query whether the clipboard exists and contains a non-empty text string.

Returns
  true if the clipboard has text, or false if it does not.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetClipboardText
  SDL_SetClipboardText

## SDL_HasPrimarySelectionText()

bool SDL_HasPrimarySelectionText | ( | void |  | ) |

extern

Query whether the primary selection exists and contains a non-empty text string.

Returns
  true if the primary selection has text, or false if it does not.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetPrimarySelectionText
  SDL_SetPrimarySelectionText

## SDL_SetClipboardData()

bool SDL_SetClipboardData | ( | SDL_ClipboardDataCallback | callback,
|  | SDL_ClipboardCleanupCallback | cleanup,
|  | void * | userdata,
|  | const char ** | mime_types,
|  | size_t | num_mime_types
| ) |  |

extern

Offer clipboard data to the OS.

Tell the operating system that the application is offering clipboard data for each of the provided mime-types. Once another application requests the data the callback function will be called, allowing it to generate and respond with the data for the requested mime-type.

The size of text data does not include any terminator, and the text does not need to be null terminated (e.g. you can directly copy a portion of a document).

Parameters

  callback | a function pointer to the function that provides the clipboard data.
  cleanup | a function pointer to the function that cleans up the clipboard data.
  userdata | an opaque pointer that will be forwarded to the callbacks.
  mime_types | a list of mime-types that are being offered.
  num_mime_types | the number of mime-types in the mime_types list.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_ClearClipboardData
  SDL_GetClipboardData
  SDL_HasClipboardData

## SDL_SetClipboardText()

bool SDL_SetClipboardText | ( | const char * | text | ) |

extern

# CategoryClipboard

SDL provides access to the system clipboard, both for reading information from other processes and publishing information of its own.

This is not just text! SDL apps can access and publish data by mimetype.

## Basic use (text)

Obtaining and publishing simple text to the system clipboard is as easy as calling SDL_GetClipboardText() and SDL_SetClipboardText(), respectively. These deal with C strings in UTF-8 encoding. Data transmission and encoding conversion is completely managed by SDL.

## Clipboard callbacks (data other than text)

Things get more complicated when the clipboard contains something other than text. Not only can the system clipboard contain data of any type, in some cases it can contain the same data in different formats! For example, an image painting app might let the user copy a graphic to the clipboard, and offers it in .BMP, .JPG, or .PNG format for other apps to consume.

Obtaining clipboard data ("pasting") like this is a matter of calling SDL_GetClipboardData() and telling it the mimetype of the data you want. But how does one know if that format is available? SDL_HasClipboardData() can report if a specific mimetype is offered, and SDL_GetClipboardMimeTypes() can provide the entire list of mimetypes available, so the app can decide what to do with the data and what formats it can support.

Setting the clipboard ("copying") to arbitrary data is done with SDL_SetClipboardData. The app does not provide the data in this call, but rather the mimetypes it is willing to provide and a callback function. During the callback, the app will generate the data. This allows massive data sets to be provided to the clipboard, without any data being copied before it is explicitly requested. More specifically, it allows an app to offer data in multiple formats without providing a copy of all of them upfront. If the app has an image that it could provide in PNG or JPG format, it doesn't have to encode it to either of those unless and until something tries to paste it.

## Primary Selection

The X11 and Wayland video targets have a concept of the "primary selection" in addition to the usual clipboard. This is generally highlighted (but not explicitly copied) text from various apps. SDL offers APIs for this through SDL_GetPrimarySelectionText() and SDL_SetPrimarySelectionText(). SDL offers these APIs on platforms without this concept, too, but only so far that it will keep a copy of a string that the app sets for later retrieval; the operating system will not ever attempt to change the string externally if it doesn't support a primary selection. Put UTF-8 text into the clipboard.

Parameters

  text | the text to store in the clipboard.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetClipboardText
  SDL_HasClipboardText

## SDL_SetPrimarySelectionText()

bool SDL_SetPrimarySelectionText | ( | const char * | text | ) |

extern

Put UTF-8 text into the primary selection.

Parameters

  text | the text to store in the primary selection.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety This function should only be called on the main thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetPrimarySelectionText
  SDL_HasPrimarySelectionText